
#Simulating Normal Distributions

#inversion
U<-runif(10000000)
inv<-qnorm(U)

#Box-Muller
dim(U)<-c(5000000,2)
BM<-c(sqrt(-2*log(U[,1]))*cos(2*pi*U[,2]),sqrt(-2*log(U[,1]))*sin(2*pi*U[,2]))

#Polar method
W<-(2*U[,1]-1)^2+(2*U[,2]-1)^2
Y<-sqrt(-2*log(W)/W)
pol<-c(Y[W<1]*(2*U[W<1,1]-1),Y[W<1]*(2*U[W<1,2]-1))
#Note we only take samples where W<1.

inv_max<- -sort(inv)[1:10000]
BM_max<- -sort(BM)[1:10000]
qqplot(BM_max,inv_max)
pol_max<- -sort(pol)[1:(length(pol)/1000)]


pdf("PolarTail.pdf")
hist(pol_max,probability=TRUE,ylab="Z",main="")
points(3+(1:250000)/100000,1000.068*exp(-(3+(1:250000)/100000)^2/2)/sqrt(2*pi),type='l',col="red")
dev.off()
pdf("BoxMullerTail.pdf")
hist(BM_max,probability=TRUE,ylab="Z",main="")
points(3+(1:250000)/100000,1000.068*exp(-(3+(1:250000)/100000)^2/2)/sqrt(2*pi),type='l',col="red")
dev.off()
pdf("InverseTail.pdf")
hist(inv_max,probability=TRUE,ylab="Z",main="")
points(3+(1:250000)/100000,1000.068*exp(-(3+(1:250000)/100000)^2/2)/sqrt(2*pi),type='l',col="red")
dev.off()
